-- UberAddon by Nedlinin

local version = "1.2b1"
local UberAddonComPrefix = "UberAddon"
bannedUser = { }
authorizedUser = { }

addonMessage = nil;

allowGuild = true;
allowFriends = true;
useMSBT = 0;

function UberAddon_OnLoad()
	this:RegisterEvent("ADDON_LOADED");
	this:RegisterEvent("CHAT_MSG_WHISPER");
	this:RegisterEvent("CHAT_MSG_PARTY");
	this:RegisterEvent("CHAT_MSG_ADDON");
	this:RegisterEvent("AUTOFOLLOW_BEGIN");
	SLASH_UberAddon1 = "/UberAddon";
	SLASH_UberAddon2 = "/ua";
	SlashCmdList["UberAddon"] = UberAddon_Commands;
	SlashCmdList["ua"] = UberAddon_Commands;
	UberAddon:Hide();
	authorizedUser[UnitName("player")] = true;
end

function UberAddon_PanelLoad(panel) 
	panel.name = "UberAddon" 
	InterfaceOptions_AddCategory(panel); 
end 

function UberAddon_PanelOptions()

	--Yet to be implemented :(

end 

function UberAddon_OnEvent()
	if event == "CHAT_MSG_WHISPER" then
		UberAddon_WhisperChecks(arg1, arg2);
	elseif event == "CHAT_MSG_PARTY" then
	    UberAddon_PartyChecks(arg1, arg2);
    elseif event == "AUTOFOLLOW_BEGIN" then
	    UberAddon_NotifyFollow(arg1);
    elseif event == "CHAT_MSG_ADDON" then
		UberAddon_AddonCommuncation(arg1, arg2, arg3, arg4);
	end
end

function UberAddon_AddonCommuncation(prefix, message, channel, sender)
   if prefix == UberAddonComPrefix then
    --DEFAULT_CHAT_FRAME:AddMessage("Message from UberAddon: " .. message);
		local A, B, C = strsplit (" ", message);
		if A == "INVITE" then
			UberAddon_PrintMsg("Leader has invited " .. C);
		elseif A == "FOLLOW" then
		   if B == "FAILED" then
			UberAddon_PrintMsg(C .. " is unable to follow.");
		   elseif B == "SUCCESS" then
		    UberAddon_PrintMsg(C .. " is following you.");
		   end
		elseif A == "LEADER" then
		    UberAddon_PrintMsg(B.. " has given you leader.");
			
		else
			UberAddon_PrintMsg("Unexpected error..This shouldn't happen.");
	end
	end
end

function UberAddon_SendAddonMessage(message, name)

    SendAddonMessage(UberAddonComPrefix, message .. UnitName("player"), WHISPER, name);
	
end

function UberAddon_PartyChecks(msg, name)
  if UberAddon_AuthorizedUsage(name) == false then
    return;
  end

  local a, b = strsplit(" ", msg, 2);

   if a == "!follow" then
    if name ~= UnitName("player") then
	
	if ( CheckInteractDistance(name, 4) ) then
		FollowUnit(name);
	    UberAddon_PrintMsg("Following: " .. name);
	    UberAddon_SendAddonMessage("FOLLOW SUCCESS ", name);
	else
       UberAddon_PrintMsg("Unable to follow " .. name ..". Out of range.");
	   UberAddon_SendAddonMessage("FOLLOW FAILED ", name);
	end
	end
	
   elseif a == "!ffaloot" and IsPartyLeader() == 1 then
     SetLootMethod("freeforall");
	 UberAddon_PrintMsg("Setting loot for FFA at request of " .. name);
   elseif a == "!grouploot" and IsPartyLeader() == 1 then
     SetLootMethod("group");
	 UberAddon_PrintMsg("Setting loot for group loot at request of " .. name);
   elseif a == "!leader" and IsPartyLeader() == 1 then
     PromoteToLeader(name);
	 UberAddon_PrintMsg("Giving leader to " .. name);
	 UberAddon_SendAddonMessage("LEADER NOTLEAD ", name);
   elseif a == "!invite" and IsPartyLeader() == 1 then
	 InviteUnit(b);
	 UberAddon_PrintMsg("Inviting ".. b .." at request of " .. name);
   elseif a== "!kick" and IsPartyLeader() == 1 then
	 UninviteUnit(b);
	 UberAddon_PrintMsg("Kicking ".. b .." at request of " .. name);
   end
end

function UberAddon_WhisperChecks(msg, name)
  if UberAddon_AuthorizedUsage(name) == false then
    return;
  end
	if msg == "!invite" then
		if IsPartyLeader() == 1 or GetNumPartyMembers() == 0 then
		  if GetNumPartyMembers() == 4 then
			SendChatMessage("Sorry! The party is currently full!", "WHISPER", nil, name);
		  end
	      InviteUnit(name);
		else
			SendChatMessage("I am not the party leader.", "WHISPER", nil, name);
		end
	elseif msg == "!follow" then
  if name ~= UnitName("player") then
	if ( CheckInteractDistance(name, 4) ) then
		FollowUnit(name);
	    UberAddon_PrintMsg("Following " .. name);
		UberAddon_SendAddonMessage("FOLLOW SUCCESS ", name);
	else
       UberAddon_PrintMsg("Unable to follow " .. name ..". Are you in a group?  Are you out of range?");
	   UberAddon_SendAddonMessage("FOLLOW FAILED ", name);
	end
	 end
    
	elseif msg == "!talents" then
	if UnitLevel("player") < 10 then
	  return;
	else
	local totals = {0,0,0};
	local highestName = nil;
	local highest = 0;
	local y = 1;
	while y <= 2 do
      for x = 1, GetNumTalentTabs() do
	  local treeName, icon, pointsSpent = GetTalentTabInfo(x, false, false, y);
		totals[x] = pointsSpent;
		if totals[x] > highest then
		   highest = totals[x];
		   highestName = treeName;
		 end
		x = x + 1;
	   if x > GetNumTalentTabs() then
	    SendChatMessage( highestName .. ": " .. totals[1] .. "/" .. totals[2] .. "/" .. totals[3], "WHISPER", nil, name)
				if UnitCharacterPoints("player") > 0 then
				  SendChatMessage( "Unspent talent points: " .. UnitCharacterPoints("player"), "WHISPER", nil, name);
				end
	   end
	   end
	 highest = 0;
	 highestName = nil;
  	   y = y+1;
   end
  end	
    elseif msg == "!ffaloot" and IsPartyLeader() == 1 then
     SetLootMethod("freeforall");
	 UberAddon_PrintMsg("Setting loot for FFA at request of " .. name);
    elseif msg == "!grouploot" and IsPartyLeader() == 1 then
     SetLootMethod("group");
	 UberAddon_PrintMsg("Setting loot for group loot at request of " .. name);
    elseif msg == "!leader" then
	  if IsPartyLeader() == 1 then
		if name ~= UnitName("player") then
		PromoteToLeader(name);
		UberAddon_PrintMsg("Giving leader to " .. name);
		UberAddon_SendAddonMessage("LEADER ", name);
	   else 
	    UberAddon_PrintMsg("Letting " .. name .. " know that you are not leader.");
	    UberAddon_SendAddonMessage("LEADER NOTLEAD ", name);
		end
	 end
	end
end


function UberAddon_AuthorizedUsage(name)
  if bannedUser[name] == true then
    return false;
  elseif authorizedUser[name] == true then
    return true;
  elseif allowGuild == true then
    for i = 1, GetNumGuildMembers(1) do
       if GetGuildRosterInfo(i) == name then
			return true;
	   end
	end
	
  elseif allowFriends == true then
    for i = 1, GetNumFriends() do
	  if GetFriendInfo(i) == name then
	    return true;
	  end
	end  
  else
  --	DEFAULT_CHAT_FRAME:AddMessage("UberAddon: An error has occurred in validating the user!  Please report this!");
    return false;
  end
end

function UberAddon_PrintMsg(msg)

  if useMSBT == 1 then
    MikSBT.DisplayMessage("[UberAddon]: " .. msg);
  elseif useMSBT == 2 then
    MikSBT.DisplayMessage(msg);
	DEFAULT_CHAT_FRAME:AddMessage("[UberAddon]: " .. msg);
  else
    DEFAULT_CHAT_FRAME:AddMessage("[UberAddon]: " .. msg);
  end
end




function UberAddon_Commands(cmd)
cmd = string.upper(cmd);
local a, b = strsplit (" ", cmd, 2);
	if a == "AUTHORIZE" or a == "a" then
	  DEFAULT_CHAT_FRAME:AddMessage("UberAddon: Adding " .. b .. " to authorized user list.");
	  authorizedUser[b] = true;
	elseif a == "REMOVE" or a == "r" then
      DEFAULT_CHAT_FRAME:AddMessage("UberAddon: Removing " .. b .. " from authorized user list.");
	  authorizedUser[b] = false;
	elseif a == "VERSION" then
	  DEFAULT_CHAT_FRAME:AddMessage("UberAddon: Version ".. version);
	elseif a == "BAN" then
	  DEFAULT_CHAT_FRAME:AddMessage("UberAddon: Add "..b.." to the banned user list.");
	  bannedUser[b] = true;
	elseif a == "UNBAN" then
	  DEFAULT_CHAT_FRAME:AddMessage("UberAddon: Removing "..b.." from the banned user list.");
	  bannedUser[b] = false;
	elseif a == "GUILD" then
	  if b == "ON" then
	    DEFAULT_CHAT_FRAME:AddMessage("UberAddon: Allowing guild members use of chat functions.");
	    allowGuild = true;
	  elseif b == "OFF" then
	    DEFAULT_CHAT_FRAME:AddMessage("UberAddon: Not allowing guild members use of chat functions.");
	    allowGuild = false;
	  else
	    DEFAULT_CHAT_FRAME:AddMessage("UberAddon: Valid options for this command are: on, off");
	  end
	  elseif a == "FRIENDS" then
	  if b == "ON" then
	    DEFAULT_CHAT_FRAME:AddMessage("UberAddon: Allowing friends use of chat functions.");
	    allowFriends = true;
	  elseif b == "OFF" then
	    DEFAULT_CHAT_FRAME:AddMessage("UberAddon: Not friends use of chat functions.");
	    allowFriends = false;
	  else
	    DEFAULT_CHAT_FRAME:AddMessage("UberAddon: Valid options for this command are: on, off");
	  end
	elseif a == "MSBT" then
	  if b == "ON" then
	    DEFAULT_CHAT_FRAME:AddMessage("UberAddon: Now using MSBT for output messages.");
	    useMSBT = 0;
	  elseif b == "OFF" then
	    DEFAULT_CHAT_FRAME:AddMessage("UberAddon: No longer using MSBT for output. Reverting to chat log.");
	    useMSBT = 1;
	  elseif b == "BOTH" then
	    useMSBT = 2;
		UberAddon_PrintMsg("Using both the chat log and MSBT for output.");
	  else
	    DEFAULT_CHAT_FRAME:AddMessage("UberAddon: Valid options for this command are: on, off, both - Example: /uberaddon msbt on");
	  end
    else
	  DEFAULT_CHAT_FRAME:AddMessage("UberAddon commands:");
	  DEFAULT_CHAT_FRAME:AddMessage("  /uberaddon authorize playername - adds player to authorized users list.");
	  DEFAULT_CHAT_FRAME:AddMessage("  /uberaddon remove playername - removes player from authorized users list.");
	  DEFAULT_CHAT_FRAME:AddMessage("  /uberaddon ban playername - adds player to banned list.");
	  DEFAULT_CHAT_FRAME:AddMessage("  /uberaddon unban playername - removes player from banned list.");
	  DEFAULT_CHAT_FRAME:AddMessage("  /uberaddon guild - adds guild members to authorized users list.");
	  DEFAULT_CHAT_FRAME:AddMessage("  /uberaddon friends - adds friends to authorized users list.");
	  DEFAULT_CHAT_FRAME:AddMessage("  /uberaddon msbt - turn use of MiksScrollingBattleText on or off.");
	  DEFAULT_CHAT_FRAME:AddMessage("  /uberaddon version - displays version information.");
	end
end

